<!DOCTYPE html>
<html lang="en">

<head>
  <title>Task 150 - Comment detail</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body>
    <div class="container">
        <div class="row form-group my-4">
            <div class="col-sm-3">
            </div>
            <div class="col-sm-8">
                <h4><b style="color: violet;">CHI TIẾT</b> COMMENT (BÌNH LUẬN)</h4>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label>Id</label>
            </div>
            <div class="col-sm-8">
                <input id = "inp-id" class="bg-light form-control" type="text">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label>Post ID</label>
            </div>
            <div class="col-sm-8">
                <input id = "inp-post-id" class="bg-light form-control" type="text">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label>Email</label>
            </div>
            <div class="col-sm-8">
                <input id = "inp-email" class="bg-light form-control" type="text">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label>Name</label>
            </div>
            <div class="col-sm-8">
                <input id = "inp-name" class="bg-light form-control" type="text">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label>Body</label>
            </div>
            <div class="col-sm-8">
                <textarea id = "textarea-body" class="bg-light form-control" type="text"></textarea>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";

    /*** REGION 1 - Global variables - Vùng khai báo hằng số, tham số TOÀN CỤC */

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
        onPageLoading();
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm xử lý sự kiện lấy post của người dùng (4 bước xử lý)
    function onPageLoading() {
        "use strict";
        //1.read data
        var vUserObj = { 
            postId : "" 
        };
        thuThapThongTin(vUserObj); 
        //2.validate
        var vKiemTra = kiemTraThongTin(vUserObj);
        if (vKiemTra) {      
            callApiGetUserDetailComment(vUserObj);  //3. gọi server
        }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm thu thap du liệu
    function thuThapThongTin(paramUser) {
        "use strict";
        var vUrlString = window.location.href;
        var vURL = new URL(vUrlString);
        var vPostId = vURL.searchParams.get("id");
    
        paramUser.postId = vPostId;
    }
    // validate data
    function kiemTraThongTin(paramUser) {
        "use strict";
        if (paramUser.postId === "") {
            alert ("Chưa nhập dữ liệu !");
            return false;
        } 
        if (isNaN( paramUser.postId)) {
            alert ("Dữ liệu là số nguyên !");
            return false;
        } 
        return true;
    }

    //Gọi Api
    function callApiGetUserDetailComment(paramUser){
        "use strict";
        const vURL_GET_POST_DETAIL = "https://jsonplaceholder.typicode.com/comments/" + paramUser.postId;
        $.ajax({
            url: vURL_GET_POST_DETAIL,
            type: 'GET',
            dataType: 'json', // added data type
            success: function (responseObject) {
                console.log(JSON.stringify(responseObject));  
                //bước 4. xử lý hiện thị 
                hienThiDuLieuPost(responseObject);  
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText);
            }
        });
    }

    //hiện thị dữ liệu 
    function hienThiDuLieuPost(paramUser) {
        "use strict";
        $("#inp-id").val(paramUser.id);
        $("#inp-post-id").val(paramUser.postId);
        $("#inp-email").val(paramUser.email);
        $("#inp-name").val(paramUser.name);
        $("#textarea-body").val(paramUser.body);
    }
  </script>

</html>